// UserInfoCtl.cpp : Implementation of the CUserInfoCtrl OLE control class.

#include "stdafx.h"
#include "UserInfo.h"
#include "UserInfoCtl.h"
#include "UserInfoPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CUserInfoCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CUserInfoCtrl, COleControl)
	//{{AFX_MSG_MAP(CUserInfoCtrl)
	// NOTE - ClassWizard will add and remove message map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CUserInfoCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CUserInfoCtrl)
	DISP_PROPERTY_NOTIFY(CUserInfoCtrl, "UserCompany", m_userCompany, OnUserCompanyChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CUserInfoCtrl, "UserName", m_userName, OnUserNameChanged, VT_BSTR)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CUserInfoCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CUserInfoCtrl, COleControl)
	//{{AFX_EVENT_MAP(CUserInfoCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CUserInfoCtrl, 1)
	PROPPAGEID(CUserInfoPropPage::guid)
END_PROPPAGEIDS(CUserInfoCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CUserInfoCtrl, "USERINFO.UserInfoCtrl.1",
	0xf0c57da3, 0x8b55, 0x11d0, 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CUserInfoCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DUserInfo =
		{ 0xf0c57da1, 0x8b55, 0x11d0, { 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb } };
const IID BASED_CODE IID_DUserInfoEvents =
		{ 0xf0c57da2, 0x8b55, 0x11d0, { 0x98, 0x87, 0, 0xa0, 0x24, 0xda, 0x5f, 0xb } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwUserInfoOleMisc =
	OLEMISC_INVISIBLEATRUNTIME |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CUserInfoCtrl, IDS_USERINFO, _dwUserInfoOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CUserInfoCtrl::CUserInfoCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CUserInfoCtrl

BOOL CUserInfoCtrl::CUserInfoCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_USERINFO,
			IDB_USERINFO,
			afxRegApartmentThreading,
			_dwUserInfoOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CUserInfoCtrl::CUserInfoCtrl - Constructor

CUserInfoCtrl::CUserInfoCtrl()
{
	InitializeIIDs(&IID_DUserInfo, &IID_DUserInfoEvents);

   LONG    ulResult;      //Result of function calls.
   LPCTSTR lpSubKey;      //Key value that we're looking for.
   HKEY    hkUser;        //Handle of key.
   CHAR    sNVName[128];  //Name of the user name value.
   DWORD   dwNVNameLen;   //Length of the user name value.
   UCHAR   sNValue[128];  //User name.
   DWORD   dwNValueLen;   //Length of the user name.
   CHAR    sCVName[128];  //Name of the company name value.
   DWORD   dwCVNameLen;   //Length of the company name value.
   UCHAR   sCValue[128];  //Company name.
   DWORD   dwCValueLen;   //Length of the company name.

   // Begin by opening the registry key.
   lpSubKey = "Software\\Microsoft\\MS Setup (ACME)\\User Info";
   ulResult = RegOpenKeyEx(HKEY_CURRENT_USER, lpSubKey, NULL, KEY_READ, &hkUser);
   if (ulResult != ERROR_SUCCESS)
   {
      MessageBox("Failed to Open Registry Key", "Initialization Error", MB_ICONERROR | MB_OK);
   }

   //Get the user name from the information in the registry 
   //and place it in our UserName control property.
   dwNVNameLen = sizeof(sNVName);
   dwNValueLen = sizeof(sNValue);
   ulResult = RegEnumValue(hkUser, 0, sNVName, &dwNVNameLen, NULL, NULL, sNValue, &dwNValueLen);
   if (ulResult != ERROR_SUCCESS)
   {
      MessageBox("Failed to Get Name", "Value Read Error", MB_ICONERROR | MB_OK);
   }
   m_userName = sNValue;

   //Get the user company from the information in the registry 
   //and place it in our UserName control property.
   dwCVNameLen = sizeof(sCVName);
   dwCValueLen = sizeof(sCValue);
   ulResult = RegEnumValue(hkUser, 1, sCVName, &dwCVNameLen, NULL, NULL, sCValue, &dwCValueLen);
   if (ulResult != ERROR_SUCCESS)
   {
      MessageBox("Failed to Get Company", "Value Read Error", MB_ICONERROR | MB_OK);
   }
   m_userCompany = sCValue;
      
   // Close the opened registry key.
   RegCloseKey(hkUser);
}


/////////////////////////////////////////////////////////////////////////////
// CUserInfoCtrl::~CUserInfoCtrl - Destructor

CUserInfoCtrl::~CUserInfoCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CUserInfoCtrl::OnDraw - Drawing function

void CUserInfoCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	pdc->Ellipse(rcBounds);
}


/////////////////////////////////////////////////////////////////////////////
// CUserInfoCtrl::DoPropExchange - Persistence support

void CUserInfoCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CUserInfoCtrl::OnResetState - Reset control to default state

void CUserInfoCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CUserInfoCtrl::AboutBox - Display an "About" box to the user

void CUserInfoCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_USERINFO);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CUserInfoCtrl message handlers

void CUserInfoCtrl::OnUserCompanyChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CUserInfoCtrl::OnUserNameChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}
